# ehrapy

ehrapy is a modular open-source Python framework designed for exploratory end-to-end analysis of heterogeneous epidemiology and electronic health record data.

![overview](https://github.com/user-attachments/assets/7927aa20-751c-4e73-8939-1e4b1c465570)

```{eval-rst}
.. card:: Installation :octicon:`plug;1em;`
    :link: installation
    :link-type: doc

    New to *ehrapy*? Check out the installation guide.
```

```{eval-rst}
.. card:: API reference :octicon:`book;1em;`
    :link: api
    :link-type: doc

    The API reference contains a detailed description of the ehrapy API.
```

```{eval-rst}
.. card:: Tutorials :octicon:`play;1em;`
    :link: tutorials/index
    :link-type: doc

    The tutorials walk you through real-world applications of ehrapy.
```

```{eval-rst}
.. card:: Discussion :octicon:`megaphone;1em;`
    :link: https://discourse.scverse.org/

    Need help? Reach out on our forum to get your questions answered!

```

```{eval-rst}
.. card:: GitHub :octicon:`mark-github;1em;`
    :link: https://github.com/theislab/ehrapy

    Find a bug? Interested in improving ehrapy? Checkout our GitHub for the latest developments.

```

```{toctree}
:caption: 'General'
:hidden: true
:maxdepth: 3

installation
api
contributing
changelog
references
```

```{toctree}
:caption: 'Gallery'
:hidden: true
:maxdepth: 3

tutorials/index
```

```{toctree}
:caption: 'About'
:hidden: true
:maxdepth: 1
about/background
about/cite
GitHub <https://github.com/theislab/ehrapy>
```

# Citation

```bibtex
@article{Heumos2024,
  author = {Heumos, Lukas and Ehmele, Philipp and Treis, Tim and Upmeier zu Belzen, Julius and Roellin, Eljas and May, Lilly and Namsaraeva, Altana and Horlava, Nastassya and Shitov, Vladimir A. and Zhang, Xinyue and Zappia, Luke and Knoll, Rainer and Lang, Niklas J. and Hetzel, Leon and Virshup, Isaac and Sikkema, Lisa and Curion, Fabiola and Eils, Roland and Schiller, Herbert B. and Hilgendorff, Anne and Theis, Fabian J.},
  year = {2024},
  month = {11},
  day = {01},
  title = {An open-source framework for end-to-end analysis of electronic health record data},
  journal = {Nature Medicine},
  volume = {30},
  number = {11},
  pages = {3369--3380},
  issn = {1546-170X},
  doi = {10.1038/s41591-024-03214-0},
  url = {https://doi.org/10.1038/s41591-024-03214-0}
}
```
